package com.fp.persistence.pgeneral.date;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.Query;

import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Transient;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla
 * TGENENOTACCOUNTINGDAY
 */
@Entity(name = "TgeneNotAccountingDay")
@Table(name = "TGENENOTACCOUNTINGDAY")
public class TgeneNotAccountingDay extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean,
		Cloneable {
	/**
	 * HashCode asociado con la Instancia
	 */
	@Transient
	private int hashValue = 0;
	/**
	 * Version de la Clase
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * Clave primaria de la Entidad TgeneNotAccountingDay
	 */
	@EmbeddedId
	private TgeneNotAccountingDayKey pk;
	@Column(name = "CATALOGCODE", nullable = true)
	/**
	 * Codigo de tabla de catalogo MONTHS, Asociado a los meses del anio
	 */
	private String catalogcode;

	@Version
	@Column(name = "RECORDVERSION", nullable = true)
	/**
	 * Optimistic locking del registro
	 */
	private Integer recordversion;

	/** Contructor por defecto */
	public TgeneNotAccountingDay() {
	}

	/**
	 * Contructor de TgeneNotAccountingDay
	 * 
	 * @param pPk Clave Primaria del entity
	 */
	public TgeneNotAccountingDay(TgeneNotAccountingDayKey pPk) {
		this();
		pk = pPk;
	}

	/**
	 * Metodo que entrega datos de la tabla dada la clave primaria.
	 * 
	 * @param pEntityManager referencia de la session a obtener datos del bean.
	 * @param pKey Caleve primaria del bean.
	 * @return TgeneNotAccountingDay
	 */
	public static TgeneNotAccountingDay find(EntityManager pEntityManager, TgeneNotAccountingDayKey pKey)
			throws Exception {
		TgeneNotAccountingDay obj = pEntityManager.find(TgeneNotAccountingDay.class, pKey);
		return obj;
	}

	/**
	 * Entrega la Clave primaria de TgeneNotAccountingDay
	 * 
	 * @return El objeto que referencia a la Clave primaria de
	 *         TgeneNotAccountingDay
	 */
	public TgeneNotAccountingDayKey getPk() {
		return pk;
	}

	/**
	 * Fija un nuevo valor a la Clave primaria de TgeneNotAccountingDay
	 * 
	 * @param pPk El objeto que referencia a la nueva Clave primaria de
	 *            TgeneNotAccountingDay
	 */
	public void setPk(TgeneNotAccountingDayKey pPk) {
		pk = pPk;
	}

	/**
	 * Obtiene el valor de catalogcode
	 * 
	 * @return valor de catalogcode
	 */
	public String getCatalogcode() {
		return catalogcode;
	}

	/**
	 * Fija el valor de catalogcode
	 * 
	 * @param pCatalogcode nuevo Valor de catalogcode
	 */
	public void setCatalogcode(String pCatalogcode) {
		catalogcode = pCatalogcode;
	}

	/**
	 * Obtiene el valor de recordversion
	 * 
	 * @return valor de recordversion
	 */
	public Integer getRecordversion() {
		return recordversion;
	}

	/**
	 * Fija el valor de recordversion
	 * 
	 * @param pRecordversion nuevo Valor de recordversion
	 */
	public void setRecordversion(Integer pRecordversion) {
		recordversion = pRecordversion;
	}

	public boolean equals(Object rhs) {
		if (rhs == null)
			return false;
		if (!(rhs instanceof TgeneNotAccountingDay))
			return false;
		TgeneNotAccountingDay that = (TgeneNotAccountingDay) rhs;
		if (this.getPk() == null || that.getPk() == null)
			return false;
		return (this.getPk().equals(that.getPk()));
	}

	/**
	 * Implementación del metodo hashCode de la la entidad TgeneNotAccountingDay
	 * 
	 * @return el hashCode la instancia
	 */
	public int hashCode() {
		if (this.hashValue == 0) {
			int result = 17;
			if (this.getPk() == null) {
				result = super.hashCode();
			} else {
				result = this.getPk().hashCode();
			}
			this.hashValue = result;
		}
		return this.hashValue;
	}

	/** Implementación toString */
	public String toString() {
		Field[] fs = this.getClass().getDeclaredFields();
		String data = "";
		for (Field f : fs) {
			try {
				String name = f.getName();
				if (f.getType().getName().compareTo("java.util.Set") == 0)
					continue;
				if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0)
					continue;
				data += name + "=" + f.get(this) + ";";
			} catch (Exception e) {
				continue;
			}
		}
		if (data.compareTo("") == 0) {
			data = super.toString();
		}
		return data;
	}

	/** Implementación de la creación de un bean en blanco TgeneNotAccountingDay */
	public Object createInstance() {
		TgeneNotAccountingDay instance = new TgeneNotAccountingDay();
		instance.setPk(new TgeneNotAccountingDayKey());
		return instance;
	}

	/**
	 * Clona la entidad TgeneNotAccountingDay
	 * 
	 * @see com.fp.dto.hb.HibernateBean#cloneMe()
	 */
	public Object cloneMe() throws CloneNotSupportedException {
		TgeneNotAccountingDay p = (TgeneNotAccountingDay) this.clone();
		p.setPk((TgeneNotAccountingDayKey) this.pk.cloneMe());
		return p;
	}
	
	//METODOS MANUALES
	
	/**
	 * Metodo que entrega una lista de dias no contables por mes. 
	 */
	@SuppressWarnings("unchecked")
	public static List<TgeneNotAccountingDay> findAll(EntityManager pEntityManager) throws Exception {
		List<TgeneNotAccountingDay>  obj = null;
		Query qry = pEntityManager.createQuery("from TgeneNotAccountingDay t order by t.pk.catalog, t.pk.day ");
		obj = qry.getResultList();
		return obj;
	}
	
	
}
